#include <vector>
#include <list>
#include <fstream>
#include <iostream>

using std::ifstream;
using std::vector;
using std::list;
using std::cerr;
using std::endl;
using std::cout;

#include <stdio.h>

#include "Image.h"
#include "Harris.h"
#include "FeaturePoint.h"
#include "FeaturePointTable.h"

/*const FeaturePoint &FeaturePointTable::operator[](int i) const
  {
  assert(0<=i&&i<(int)table.size());
  return table[i];
  }
	
  FeaturePoint &FeaturePointTable::operator[](int i)
  {
  assert(0<=i&&i<(int)table.size());
  return table[i];
  }
	
  int FeaturePointTable::size() const
  {
  return (int) table.size();
  }*/
	
//ɸΰĹ¤û¤¤ʿ
double
FeaturePointTable::get_avg_covariance() const 
{
   int num = table.size();
   double total=0.0;
   for(int i=0; i<num; i++)
      total+=trace(table[i].Axis);
   return total/(2*num);
}

//ħե뤫ϡ
//եޥåȤ  (u,v) 
bool
FeaturePointTable::input_from_file(const char *fn)
{
   char buf[1024];
   ifstream fin(fn);
   if(!fin){
      cerr <<"can't open \""<< fn <<"\"."<<endl;
      exit(1);
   }
  
   FeaturePoint pt;
   int u,v;
   fin.getline(buf,1024);  
   while(!fin.eof()){
      sscanf(buf, "(%d,%d)" ,&u,&v);
      pt.point[0] = u;
      pt.point[1] = v;
      fin.getline(buf,1024);
      pt_list.push_back(pt);
   }
   return true;
}

//ħHarrisڥ졼Ѥ
bool
FeaturePointTable::extract_from_image(const Image &im,
                                      int gauss_table_size,
                                      double gauss_var,
                                      double  rk, double th,
                                      int Pmax, int d_min)
{
   int point_num;
   int *pt_u,*pt_v;

   pt_u = new int [Pmax];
   pt_v = new int [Pmax]; 

   if(!pt_u || !pt_v)
   {
      cerr << "extract_from_image: can't get memory." << endl;
      exit(1);
   }

   ImpHarris(im, &pt_u, &pt_v, 0, &point_num, 
             gauss_table_size, gauss_var, rk, th,
             Pmax, d_min);

   FeaturePoint pt;
   for (int i=0; i<point_num; i++)
   {
      pt.point[0] = pt_u[i];
      pt.point[1] = pt_v[i];
      pt_list.push_back(pt);
   }
   delete [] pt_u;
   delete [] pt_v;
   return true;
}

//ɸΰ׻롥
// 
// im             
// gauss          ơ֥(ե륿)
// use_Derivative ɸΰ륢르ꥺ˼ʻĺǤϤʤ ʬ롣
// window_range ʬե륿Ѥ륦ɥΥ( 2*template_range + 1)
//
//
//ϲɸΰĹû¤¤ʿ
double
FeaturePointTable::calc_ellipse_parameter(const Image &im, const Gauss &gauss,
                                          bool use_Derivative,int window_range)

{
   list<FeaturePoint>::iterator it = pt_list.begin();
   //ʻĺѤƶʬ׻ơɸΰˡ
   if(!use_Derivative){
      for(;it != pt_list.end();	it++)	{
         it->calc_cov_by_residual(im, gauss);
         if(it->calc_parameter()){
            table.push_back(*it);
         }
      }
   }
		
   //ʬѤƶʬ׻ơɸΰˡ
   else {
      SmoothingFilter mask_u, mask_v;
      mask_u.make_x_filter(gauss.var, gauss.range);
      mask_v.make_y_filter(gauss.var, gauss.range);
      for(;it != pt_list.end();	it++)	{
         it->calc_cov_by_derivative(im,mask_u,mask_v,window_range);
         if(it->calc_parameter()){
            table.push_back(*it); //ꥹȤإԡ(ͭħΤ)
         }
      }
   }
   pt_list.clear();
   return get_avg_covariance();
}

bool
FeaturePointTable::normalize(double normalize_factor)
{
   int num = table.size();
   for(int i=0; i<num; i++){
      table[i].Axis[0][0] /= normalize_factor;
      table[i].Axis[1][1] /= normalize_factor;
   }
   return true;
}
