#ifndef __FEATUREPOINTTABLE_H__
#define __FEATUREPOINTTABLE_H__

#include <vector>
#include <list>

using std::ifstream;
using std::vector;
using std::list;
using std::cerr;
using std::endl;
using std::cout;

#include <assert.h>

#include "Image.h"
#include "FeaturePoint.h"

class FeaturePointTable{
  private:
   vector<FeaturePoint> table; 
   list<FeaturePoint> pt_list; //ħκΨŪ˹ԤΥƥݥ
  public:
   FeaturePointTable(){}
   ~FeaturePointTable(){table.clear();}
	
   inline const FeaturePoint &operator[](int i) const
      {
// 	  assert(0<=i&&i<(int)table.size());
         if( !(0<=i&&i<(int)table.size() ) ){
            cerr << i<<"/"<<table.size() <<endl;
         }
         assert(0<=i&&i<(int)table.size());
         return table[i];
      }
	
   inline FeaturePoint &operator[](int i)
      {
         assert(0<=i&&i<(int)table.size());
         return table[i];
      }
	
   inline int size() const
      {
         return (int) table.size();
      }
	
   //ɸΰĹ¤û¤¤ʿѤ롣
   double get_avg_covariance() const ;
	
   //ե뤫ħϤ
   bool input_from_file(const char *fn);
	
   //Harrisڥ졼ѤħФ롣
   bool extract_from_image(const Image &im,
                           int gauss_table_size, double gauss_var,
                           double  rk, double th, int Pmax, int d_min);
   //ɸΰ׻롥
   // 
   // im             
   // gauss          ơ֥(ե륿)
   // calc_type      ɸΰ륢르ꥺ(ʻĺ or ʬ)
   // window_range ʬե륿Ѥ륦ɥΥ( 2*template_range + 1)
   //
   //
   //ϲɸΰĹû¤¤ʿ
   double calc_ellipse_parameter(const Image &im, const Gauss &gauss,
                                 bool use_Derivative = false,
                                 int window_range=3);
	
   //ɸΰ
   bool normalize(double normalize_factor);
};
#endif
