/*!
 * @file Option.h
 * ޥɥ饤󥪥ץβϤӥץݻѿδ()
 * (Υե mkoption ˤäƼư줿եǤ)
 */

#if !defined OPTION_H__INCLUDED__2006479420__
#define OPTION_H__INCLUDED__2006479420__

#include <stdexcept>
#include <string>

//! ץ륯饹
class Option
{
  public:
   // ץΥǥեͤɽ
   static const std::string DEFAULT_F1_NAME;
   static const std::string DEFAULT_F2_NAME;
   static const int DEFAULT_FILTER_RANGE;
   static const int DEFAULT_WINDOW_RANGE;
   static const double DEFAULT_VAR;
   static const double DEFAULT_RK;
   static const double DEFAULT_HARRIS_TH;
   static const int DEFAULT_PMAX;
   static const int DEFAULT_HARRIS_D_MIN;
   static const double DEFAULT_D_MIN;
   static const double DEFAULT_D_MAX;
   static const int DEFAULT_DIM;
   static const int DEFAULT_RADIUS_DIV;
   static const int DEFAULT_RADIUS_SCALE;
   static const int DEFAULT_ANGLE_DIV;
   static const int DEFAULT_TRIANGLE_LENGTH;
   static const double DEFAULT_PV_TH;
   static const double DEFAULT_STR_TH;
   static const double DEFAULT_TRIANGLE_TH;
   static const double DEFAULT_VOTE_TH;
   static const double DEFAULT_PV_WEIGHT;
   static const double DEFAULT_STR_WEIGHT;
   static const double DEFAULT_TRIANGLE_WEIGHT;
   static const double DEFAULT_FOCAL_LENGTH;
   static const double DEFAULT_DISTORTION;
   static const bool DEFAULT_USE_CC;
   static const bool DEFAULT_USE_DERIVATIVE;
   static const bool DEFAULT_NO_USE_RANSAC;
   static const bool DEFAULT_VERBOSE;

   // ץ뤿δؿ
  public:
   const std::string& imgfn1() const { return imgfn1_; }
   const std::string& imgfn2() const { return imgfn2_; }
   const std::string& f1_name() const { return f1_name_; }
   bool is_set_f1_name() const { return is_set_f1_name_; }
   const std::string& f2_name() const { return f2_name_; }
   bool is_set_f2_name() const { return is_set_f2_name_; }
   int filter_range() const { return filter_range_; }
   bool is_set_filter_range() const { return is_set_filter_range_; }
   int window_range() const { return window_range_; }
   bool is_set_window_range() const { return is_set_window_range_; }
   double var() const { return var_; }
   bool is_set_var() const { return is_set_var_; }
   double rk() const { return rk_; }
   bool is_set_rk() const { return is_set_rk_; }
   double harris_th() const { return harris_th_; }
   bool is_set_harris_th() const { return is_set_harris_th_; }
   int Pmax() const { return Pmax_; }
   bool is_set_Pmax() const { return is_set_Pmax_; }
   int harris_d_min() const { return harris_d_min_; }
   bool is_set_harris_d_min() const { return is_set_harris_d_min_; }
   double d_min() const { return d_min_; }
   bool is_set_d_min() const { return is_set_d_min_; }
   double d_max() const { return d_max_; }
   bool is_set_d_max() const { return is_set_d_max_; }
   int dim() const { return dim_; }
   bool is_set_dim() const { return is_set_dim_; }
   int radius_div() const { return radius_div_; }
   bool is_set_radius_div() const { return is_set_radius_div_; }
   int radius_scale() const { return radius_scale_; }
   bool is_set_radius_scale() const { return is_set_radius_scale_; }
   int angle_div() const { return angle_div_; }
   bool is_set_angle_div() const { return is_set_angle_div_; }
   int triangle_length() const { return triangle_length_; }
   bool is_set_triangle_length() const { return is_set_triangle_length_; }
   double pv_th() const { return pv_th_; }
   bool is_set_pv_th() const { return is_set_pv_th_; }
   double str_th() const { return str_th_; }
   bool is_set_str_th() const { return is_set_str_th_; }
   double triangle_th() const { return triangle_th_; }
   bool is_set_triangle_th() const { return is_set_triangle_th_; }
   double vote_th() const { return vote_th_; }
   bool is_set_vote_th() const { return is_set_vote_th_; }
   double pv_weight() const { return pv_weight_; }
   bool is_set_pv_weight() const { return is_set_pv_weight_; }
   double str_weight() const { return str_weight_; }
   bool is_set_str_weight() const { return is_set_str_weight_; }
   double triangle_weight() const { return triangle_weight_; }
   bool is_set_triangle_weight() const { return is_set_triangle_weight_; }
   double focal_length() const { return focal_length_; }
   bool is_set_focal_length() const { return is_set_focal_length_; }
   double distortion() const { return distortion_; }
   bool is_set_distortion() const { return is_set_distortion_; }
   bool use_CC() const { return use_CC_; }
   bool is_set_use_CC() const { return is_set_use_CC_; }
   bool use_Derivative() const { return use_Derivative_; }
   bool is_set_use_Derivative() const { return is_set_use_Derivative_; }
   bool no_use_RANSAC() const { return no_use_RANSAC_; }
   bool is_set_no_use_RANSAC() const { return is_set_no_use_RANSAC_; }
   bool verbose() const { return verbose_; }
   bool is_set_verbose() const { return is_set_verbose_; }

  private:
   int required_parameter_;			//!< ɬܥѥ᡼
   std::string imgfn1_;		//!< Input Image1 filename
   std::string imgfn2_;		//!< Input Image2 filename
   std::string f1_name_;		//!< file name of Feature point for Image1
   bool is_set_f1_name_;
   std::string f2_name_;		//!< file name of Feature point for Image2
   bool is_set_f2_name_;
   int filter_range_;		//!< Gauss filter size
   bool is_set_filter_range_;
   int window_range_;		//!< Size of window when differentiation is calculated.
   bool is_set_window_range_;
   double var_;		//!< Variance value, used by Gauss filter.
   bool is_set_var_;
   double rk_;		//!< Harris-operator coefficient.
   bool is_set_rk_;
   double harris_th_;		//!< Threshold of value of Harris-operator.
   bool is_set_harris_th_;
   int Pmax_;		//!< Maximum  number of feature points.
   bool is_set_Pmax_;
   int harris_d_min_;		//!< Minimum distance between two featurepoints.
   bool is_set_harris_d_min_;
   double d_min_;		//!< Used by ProfileVector, Minimum distance.
   bool is_set_d_min_;
   double d_max_;		//!< Used by ProfileVector, Maximum distance.
   bool is_set_d_max_;
   int dim_;		//!< Division number of profile vector.
   bool is_set_dim_;
   int radius_div_;		//!< Division number of radius of standard region.
   bool is_set_radius_div_;
   int radius_scale_;		//!< Scale of radius of standard region.
   bool is_set_radius_scale_;
   int angle_div_;		//!< Division number of angle of standard region.
   bool is_set_angle_div_;
   int triangle_length_;		//!< Used by triangle vector. Division number of length.
   bool is_set_triangle_length_;
   double pv_th_;		//!< Threshold value of similarity between two profile vector.
   bool is_set_pv_th_;
   double str_th_;		//!< Threshold value of similarity between two standard region.
   bool is_set_str_th_;
   double triangle_th_;		//!< Threshold value of similarity between two triangle vector.
   bool is_set_triangle_th_;
   double vote_th_;		//!< Threshold value of vote between two feature points.
   bool is_set_vote_th_;
   double pv_weight_;		//!< Similarity weight of profile vector in Tri-vector.
   bool is_set_pv_weight_;
   double str_weight_;		//!< Similarity weight of standard region vector in Tri-vector.
   bool is_set_str_weight_;
   double triangle_weight_;		//!< Similarity weight of triangle vector .
   bool is_set_triangle_weight_;
   double focal_length_;		//!< Used by RANSAC. Focal_length. to fix scale.
   bool is_set_focal_length_;
   double distortion_;		//!< Used by RANSAC. Threshold for inliar.
   bool is_set_distortion_;
   bool use_CC_;		//!< Using SSD for calculation of similarity.
   bool is_set_use_CC_;
   bool use_Derivative_;		//!< Using Differential for calculation of covariance.
   bool is_set_use_Derivative_;
   bool no_use_RANSAC_;		//!< not Using RANSAC.
   bool is_set_no_use_RANSAC_;
   bool verbose_;		//!< verbose output.
   bool is_set_verbose_;

   // 鲼 Option 饹椹뤿δؿ̾ѹɬפʤ
  public:
   /*!
    * 󥹥ȥ饯ץѿνͤꤹ
    * @param ʤ
    */
   Option();

   /*!
    * ץϤ롥
    * @param [in] argc ο(main ؿΤΤ򤽤ΤޤϤ)
    * @param [in,out] argv (main ؿΤΤ򤽤ΤޤϤ)
    */
   void Parse(int argc, char *argv[]);

   /*!
    * @a index ǻꤵ줿ޥɥ饤Ǥ֤
    * ºݤΥޥɥ饤󥪥ץ̵ͭˤ餺
    * @a index  1 Ϳ뤳ȤǺǽ󥪥ץ뤳ȤǤ롥
    * @param [in] index 륳ޥɥ饤
    * @return ޥɥ饤Ǥ֤
    */
   char* Argument(int index);

  private:
   /*!
    * Ѳǽʥޥɥ饤󥪥ץΰϤ
    * @param [in] progname ץ̾
    */
   static void Usage(const char* progname);

   /*!
    * СϤ
    * @param [in] progname ץ̾
    */
   static void Version(const char* progname);

  private:
   static char** argv_;
};

//!< ץϢ㳰Υѡ饹
class OptionException : public std::runtime_error
{
  public:
   OptionException(const char* what) :
      std::runtime_error(what)
      {
      }
};

//! ǧǤʤץͿ줿ݤȯ㳰
class BadOptionException : public OptionException
{
  public:
   BadOptionException() : OptionException("bad option")
      {
      }
};

//! ο­Ƥݤȯ㳰
class FewArgumentException : public OptionException
{
  public:
   FewArgumentException() : OptionException("too few argument")
      {
      }
};

//! إפСϤȯ㳰
class UsageException : public OptionException
{
  public:
   UsageException() : OptionException("help or usage is showed")
      {
      }
};

#endif

