#include <iostream>

using std::cout;
using std::cerr;
using std::endl;

#include <assert.h>

#include "FeaturePointTable.h"
#include "TriVecDesc.h"
#include "Image.h"
#include "Gauss.h"
#include "TriVecDescTable.h"

//TriVectorArray
bool
TriVectorArray::make_TriVector_array(const FeaturePointTable &feature,
                                     int index,
                                     const Image &im, const Gauss &gauss,
                                     int dim, double d_min, double d_max,
                                     int radius_div, int radius_scale,
                                     int angle_div)
{
   num = (int)feature.size();
   array = new TriVector [num];
   if(!array){
      cerr << "can't get memory. make_TriVector_array()"<<endl;
      exit(1);
   }
	  
   for(int i=0; i<num; i++){
      if(index == i)continue;//ƱϽ
      array[i].make_tri_vector(im, gauss,feature[index], feature[i],
                               dim, d_min, d_max,
                               radius_div, radius_scale,angle_div);
   }
   return true;
}


//TriVectorTable
bool
TriVectorTable::make_TriVector_table(const Image &im,
                                     const FeaturePointTable &feature,
                                     const Gauss &gauss,
                                     int dim, double d_min, double d_max,
                                     int radius_div, int radius_scale,
                                     int angle_div, bool useCC)
{
   num = (int)feature.size();
   table = new TriVectorArray[num];
   if(!table){
      cerr <<"can't get memory. make_TriVector_table()"<<endl;
   }
   for(int i=0; i<num; i++){
      table[i].make_TriVector_array(feature, i,im, gauss,
                                    dim, d_min, d_max,
                                    radius_div, radius_scale,angle_div);
      //ͭʻȥ٥ȥֹݻ롣
      vector<int> useable_index_array;
      for(int j=0;j<num;j++){
         if(table[i][j].is_true())
            useable_index_array.push_back(j);	
      }
      useable_index_table.push_back(useable_index_array);
   }
  
   if(!useCC){//ʿѤ
      for(int i=0; i<num; i++){
         for(int j=0; j<num; j++){
            if(i==j)continue;
            table[i][j].normalize_SSD();
         }
      }
   }
   else{//Υ
      for(int i=0; i<num; i++){
         for(int j=0; j<num; j++){
            if(i==j)continue;
            table[i][j].normalize_CC();
         }
      }
   }
	  
   return true;
}
	
int
TriVectorTable::count_TriVector() const
{
   int count = 0;
   for(int i=0; i<num; i++){
      for(int j=0; j<num; j++){
         if(table[i][j].is_true())
            count++;
      }
   }
   return count;
}
