#ifndef __TRIVECTORTABLE_H__
#define __TRIVECTORTABLE_H__

#include <vector>
using std::vector;

#include "FeaturePointTable.h"
#include "TriVecDesc.h"
#include "Image.h"
#include "Gauss.h"

class TriVectorArray{
   TriVector* array;
   int num;
  public:
   TriVectorArray(){array = 0;num = 0;}
   ~TriVectorArray(){if(array)delete [] array;}
   int useable_num()const
      {
         int count=0;
         for(int i=0;i<num; i++){
            if(array[i].is_true())count++;
         }
         return count;
      }
	
   inline const TriVector & operator[](int i)const 
      {
         assert(0<=i&&i<num);
         return array[i];
      }
   inline TriVector & operator[](int i)
      {
         assert(0<=i&&i<num);
         return array[i];
      }
   bool make_TriVector_array(const FeaturePointTable &feature, int index,
                             const Image &im, const Gauss &gauss,
                             int dim, double d_min, double d_max,
                             int radius_div,int radius_scale, int angle_div );
};



//ȥ٥ȥơ֥
//table[i][j] ħiܤjܤδ֤ǸФ줿ȥ٥ȥɽ
class TriVectorTable{
   TriVectorArray *table;
   int num;
  public:
   vector< vector<int> > useable_index_table;
   TriVectorTable(){table = 0;num = 0;}
   ~TriVectorTable(){if(table) delete [] table;}
   inline const TriVectorArray &operator[](int i) const
      {
         assert(0<=i&& i<num);
         return table[i];
      }
   inline TriVectorArray &operator[](int i) 
      {
         assert(0<=i&& i<num);
         return table[i];
      }
   bool make_TriVector_table(const Image &im, const FeaturePointTable &feature,
                             const Gauss &gauss,
                             int dim, double d_min, double d_max,
                             int radius_div,int radius_scale, int angle_div,
                             bool useCC = false);
   int count_TriVector() const;
};
#endif
