// ijklƥ󥽥륯饹
// modified by T.Sakamoto (2001/06/13) add Fill and FillSym

#ifndef	_TENSOR_H_
#define	_TENSOR_H_

#include <Mat.h>

class Tensor4
{
    int		in, jn, kn, ln;       //줾ǿ
    double****	t;             //

  public:
    Tensor4(int i = 3, int j = 3, int k = 3, int l = 3);//1st construcotr
    Tensor4(const Tensor4&);				//copy constructor
    ~Tensor4();						//destructor

    void                clear(double data = 0.0);               // ꥢ
    void                Fill();                                 //ʣˤ3333ƥ󥽥
    void                FillSym();                              //ʣˤ(33)(33)ƥ󥽥
    double&	        operator()(int, int, int, int);		//ǼФ
    const double& 	operator()(int, int, int, int) const;	//ǼФ
    Tensor4&	        operator=(const Tensor4&);		//黻
    Tensor4&	        operator+=(const Tensor4&);		//黻
    Tensor4&	        operator-=(const Tensor4&);		//黻
    Tensor4&	        operator/=(const double);		//黻
    Tensor4&	        operator*=(const double);		//黻
    friend Tensor4	operator+(const Tensor4&, const Tensor4&);//­
    friend Tensor4	operator-(const Tensor4&, const Tensor4&);//
    friend Tensor4	operator*(const Tensor4&, const double);//
    friend Tensor4	operator*(const double, const Tensor4&);
    friend Mat		operator*(const Tensor4&, const Mat&);	//3333ƥ󥽥*33
    friend Tensor4	operator/(const Tensor4&, const double);//任
    friend Tensor4	operator-(const Tensor4&);		//ñ
    friend Tensor4	TensorProduct(const Mat&, const Mat&);//ƥ󥽥(
							//Ĥιϣߣ
							//˸¤)

    const int	DimI() const { return in; }	//줾μ
    const int	DimJ() const { return jn; }
    const int	DimK() const { return kn; }
    const int	DimL() const { return ln; }

    int		DimI() { return in; }      //줾μ                 
    int		DimJ() { return jn; }
    int		DimK() { return kn; }
    int		DimL() { return ln; }

    //(33)(33)ƥ󥽥ΰ̵դ
    friend Tensor4	GenInv3333sym(const Tensor4&, int times = 0);

    //3333ƥ󥽥ΰ̵դ
    friend Tensor4	GenInv3333(const Tensor4&, int times = 0);
};

//(33)(33)ƥ󥽥ƤθͭͤƤθͭ
int Eigen3333sym(const Tensor4&, VecC&, Mat*);

//3333ƥ󥽥ƤθͭͤƤθͭ
int Eigen3333(const Tensor4&, VecC&, Mat*);

#endif	//_TENSOR_H_
