//
// 饹 Vec, VecC, VecR γƼ黻¾
//
#include "Vec.h"
#if __GNUC__ >= 3
# include <new>
#endif

using std::cerr;
using std::endl;
using std::istream;
using std::ostream;

// ѹ
void
Vec::renew(int n)
{
   double       *p, *r, *q = vec;
   int          ni;

   if (n == _n)  return;
#if __GNUC__ < 3
   r = p = new double[n];
#else
   r = p = new(std::nothrow) double[n];
#endif
   if (r == NULL)
   {
      cerr << "### Memory Alloc Error (Vec.realoc) ###\n";
      abort();
   }

   ni = (n < _n)? n: _n;
   for (int i = 0; i < ni; i++)
      *p++ = *q++;
//   if (_n < n)
//      for (int i = _n; i < n; i++)
//         *p++ = 0.0;

   delete [] vec;
   vec = r;
   _n = n;
}

// ѹ
void
VecR::realloc(int n)
{
   Vec::renew(n);
}

void
VecC::realloc(int n)
{
   Vec::renew(n);
}

// ٥ȥ
VecC
abs(const VecC& V)
{
   VecC	        T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < T._n; i++)
      *p++ = fabs(*q++);

   return T;
}

VecR
abs(const VecR& V)
{
   VecR	        T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < T.size(); i++)
      *p++ = fabs(*q++);

   return T;
}

// ȥ꡼फγǤ
istream&
operator >> (istream& s, Vec& V)
{
   double       *p = V.vec;

   for (int i = 0; i < V._n; i++)
      s >> *p++;
   return s;
}

// ȥ꡼ؤΥ٥ȥν
ostream&
operator << (ostream& s, const VecR& V)
{
   double       *p = V.vec;

   s << "( ";
   for (int i = 0; i < V._n; i++, p++)
      s << ((fabs(*p) <= EPS)? 0: *p) << " ";
   s << ")";
   return s;
}

ostream&
operator << (ostream& s, const VecC& V)
{
   double       *p = V.vec;

   s << "( ";
   for (int i = 0; i < V._n; i++, p++)
      s << ((fabs(*p) <= EPS)? 0: *p) << " ";
   s << ")t";
   return s;
}

// 顼Ǥν
VecR
operator / (const VecR& V, double a)
{
   VecR         T(V);
   double       *p = T.vec;

   for (int i = 0; i < T._n; i++)
      *p++ /= a;
   return T;
}

VecC	operator / (const VecC& V, double a)
{
   VecC         T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < T._n; i++)
      *p++ = *q++ / a;
   return T;
}

// 顼
VecR	operator * (const VecR& V, double a)
{
   VecR         T(V);
   double       *p = T.vec;

   for (int i = 0; i < T._n; i++)
      *p++ *= a;
   return T;
}

VecC
operator * (const VecC& V, double a)
{
   VecC	        T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < T._n; i++)
      *p++ = *q++ * a;
   return T;
}

// 
double
operator , (const VecR& V1, const VecR& V2)
{
   double	x = 0;
   double       *p = V1.vec, *q = V2.vec;

   assert(V1._n == V2._n);
   for (int i = 0; i < V1._n; i++)
      x += (*p++) * (*q++);
   return x;
}

double
operator , (const VecC& V1, const VecC& V2)
{
   double	x = 0;
   double       *p = V1.vec, *q = V2.vec;

   assert(V1._n == V2._n);
   for (int i = 0; i < V1._n; i++)
      x += (*p++) * (*q++);
   return x;
}

// ñ - 黻
VecR
operator - (const VecR& V)
{
   VecR	        T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < V._n; i++)
      *p++ = -(*q++);
   return T;
}

VecC
operator - (const VecC& V)
{
   VecC	        T(V._n);
   double       *p = T.vec, *q = V.vec;

   for (int i = 0; i < V._n; i++)
      *p++ = -(*q++);
   return T;
}

// ٥ȥΥΥ (ɤǤ褤Ϥ)
double
Vec::norm() const
{
   return sqrt(this->sqrnorm());
}

// ٥ȥΥ
double
Vec::sqrnorm() const
{
   double	x = 0;
   double       *p = vec;

   for (int i = 0; i < _n; i++, p++)
      x += (*p) * (*p);
   return x;
}

// ٥ȥ
VecR
normalize(const VecR& V)
{
   VecR		T(V);
   double	d;

   if ((d = V.norm()) < EPS)
   {
      T.clear();
      return T;
   }
   else
      return V / d;
}

VecC
normalize(const VecC& V)
{
   VecC		T(V);
   double	d;

   if ((d = V.norm()) < EPS)
   {
      T.clear(0.0);
      return T;
   }
   return T / d;
}

// ٥ȥӡ
//	׻(ݤ)θ
int
operator == (const Vec& V1, const Vec& V2)
{
   double       *p = V1.vec, *q = V2.vec;

   assert(V1._n == V2._n);
   for (int i = 0; i < V1._n; i++)
      if (fabs(*p++ - *q++) > EPS)  return False;

   return True;
}

// ٥ȥӡ԰
//	׻(ݤ)θ
int
operator != (const Vec& V1, const Vec& V2)
{
   double       *p = V1.vec, *q = V2.vec;
   assert(V1._n == V2._n);
   for (int i = 0; i < V1._n; i++)
      if (fabs(*p++ - *q++) > EPS)  return True;

   return False;
}

// ٥ȥγ (3x3Τ)
VecR
operator % (const VecR& V1, const VecR& V2)
{
   double	x[3];

   assert(V1._n == 3 && V2._n == 3);
   x[0] = V1.vec[1] * V2.vec[2] - V1.vec[2] * V2.vec[1];
   x[1] = V1.vec[2] * V2.vec[0] - V1.vec[0] * V2.vec[2];
   x[2] = V1.vec[0] * V2.vec[1] - V1.vec[1] * V2.vec[0];
   return VecR(x, 3);
}

VecC
operator % (const VecC& V1, const VecC& V2)
{
   double	x[3];

   assert(V1._n == 3 && V2._n == 3);
   x[0] = V1.vec[1] * V2.vec[2] - V1.vec[2] * V2.vec[1];
   x[1] = V1.vec[2] * V2.vec[0] - V1.vec[0] * V2.vec[2];
   x[2] = V1.vec[0] * V2.vec[1] - V1.vec[1] * V2.vec[0];
   return VecC(x, 3);
}
