#include "nradd.h"

void
rc_generic_inverse(double **a, double **y, int n, int m)
 /* ͭͷ׻Ѥ̵չη׻=-Ȥʤ롣a[1..n][1..m] */
 /* y[1..m][1..n]Ǥ롣*/
 /* Ȼ:֥ޥȥꥯοͷ׻, p.46p.50 */
{
   double	**aa, **lp, **ua, **ulu, **w, *d, *e;
   int		i, j, k;

   aa = matrix(1, m, 1, m);	/* *: žֹȤ */
   				/* ˸ͭ٥ȥ */
   lp = matrix(1, m, 1, m);	/* + */
   ua = matrix(1, m, 1, m);	/* * */
   w = matrix(1, m, 1, m);	/*  */
   ulu = matrix(1, m, 1, m);	/* զ+ */
   d = recipes_vector(1, m);		/* ͭ */
   e = recipes_vector(1, m);		/*  */

   /* * */
   for (i = 1; i <= m; i++)
      for (j = 1; j <= m; j++)
      {
	 aa[i][j] = 0.0;
	 for (k = 1; k <= n; k++)
	    aa[i][j] += a[k][i] * a[k][j];	/* [i][k] * [k][j] */
						/* ž֤Ƥ뤿 */
      }

   /* *θͭͤȸͭ٥ȥ */
   tred2(aa, m, d, e);
   tqli(d, e, m, aa);
   eigsrt(d, aa, m);

   /* +, *׻ */
   for (i = 1; i <= m; i++)
      for (j = 1; j <= m; j++)
      {
	 lp[i][j] = (i != j)? 0.0: ((fabs(d[i]) <= TINY)? 0.0: 1.0 / d[i]);
	 ua[i][j] = aa[j][i];
      }
   
   /* զ+* ׻ */
   for (i = 1; i <= m; i++)
      for (j = 1; j <= m; j++)
      {
	 w[i][j] = 0.0;
	 for (k = 1; k <= m; k++)
	    w[i][j] += ua[k][i] * lp[k][j];
      }
   for (i = 1; i <= m; i++)
      for (j = 1; j <= m; j++)
      {
	 ulu[i][j] = 0.0;
	 for (k = 1; k <= m; k++)
	    ulu[i][j] += w[i][k] * ua[k][j];
      }

   /* (զ+*)*  */
   for (i = 1; i <= m; i++)
      for (j = 1; j <= n; j++)
      {
	 y[i][j] = 0.0;
	 for (k = 1; k <= m; k++)
	    y[i][j] += ulu[i][k] * a[j][k];
      }

   /* ޥȥꥯ٥ȥγ */
   free_matrix(aa, 1, m, 1, m);
   free_matrix(lp, 1, m, 1, m);
   free_matrix(ua, 1, m, 1, m);
   free_matrix(w, 1, m, 1, m);
   free_matrix(ulu, 1, m, 1, m);
   free_vector(d, 1, n);
   free_vector(e, 1, n);
}

static void
column(double **a, int m, int n, double *v, int k)
 /* a[1..m][1..n]٥ȥa[k]Ф */
{
   int	i;

   for (i = 1; i <= m; i++)
      v[i] = a[i][k];
}

void
rc_gen_inv(double **a, double **y, int m, int n)
 /* ðʬѤ̵չη׻=-Ȥʤ롣a[1..m][1..n] */
 /* y[1..n][1..m]Ǥ롣*/
{
   double	**AtA, **AAt, *s1, *s2, *e1, *e2, *s, *u, *v;
   int		i, j, k, r;

   AtA = matrix(1, n, 1, n);	/* t */
   AAt = matrix(1, m, 1, m);	/* t */

   s1 = recipes_vector(1, n);		/* tθͭ */
   s2 = recipes_vector(1, m);		/* tθͭ */
   e1 = recipes_vector(1, n);		/*  */
   e2 = recipes_vector(1, m);		/*  */
   u = recipes_vector(1, n);
   v = recipes_vector(1, m);

   s = recipes_vector(1, IMIN(n, m));

   /* tη׻ */
   for (i = 1; i <= n; i++)
      for (j = 1; j <= n; j++)
      {
	 AtA[i][j] = 0.0;
	 for (k = 1; k <= m; k++)
	    AtA[i][j] += a[k][i] * a[k][j];
      }

   /* tη׻ */
   for (i = 1; i <= m; i++)
      for (j = 1; j <= m; j++)
      {
	 AAt[i][j] = 0.0;
	 for (k = 1; k <= n; k++)
	    AAt[i][j] += a[i][k] * a[j][k];
      }

   /* tθͭͤȸͭ٥ȥ(=) */
   tred2(AtA, n, s1, e1);
   tqli(s1, e1, n, AtA);
   eigsrt(s1, AtA, n);

   /* tθͭͤȸͭ٥ȥ(=) */
   tred2(AAt, m, s2, e2);
   tqli(s2, e2, m, AAt);
   eigsrt(s2, AAt, m);

   /* r׻ */
   r = 0;
   if (n < m)
   {
      for (i = 1; i <= n; i++)
      {
	 if (s1[i] > TINY)
	 {
	    r++;
	    s[i] = 1.0 / sqrt(s1[i]);
	 }
	 else
	    s[i] = 0.0;
      }
   }
   else
   {
      for (i = 1; i <= m; i++)
      {
	 if (s2[i] > TINY)
	 {
	    r++;
	    s[i] = 1.0 / sqrt(s2[i]);
	 }
	 else
	    s[i] = 0.0;
      }
   }

   /* ꥢ */
   for (i = 1; i <= n; i++)
      for (j = 1; j <= m; j++)
	 y[i][j] = 0.0;

   for (k = 1; k <= r; k++)
   {
      column(AtA, n, n, u, k);
      for (i = 1; i <= m; i++)
      {
	 v[i] = 0.0;
	 for (j = 1; j <= n; j++)
	    v[i] += a[i][j] * u[j] * s[k];
      }

      for (i = 1; i <= n; i++)
	 for (j = 1; j <= m; j++)
	    y[i][j] += s[k] * u[i] * v[j];
   }

   /* ޥȥꥯ٥ȥγ */
   free_matrix(AtA, 1, n, 1, n);	/* t */
   free_matrix(AAt, 1, m, 1, m);	/* t */

   free_vector(s1, 1, n);		/* tθͭ */
   free_vector(s2, 1, m);		/* tθͭ */
   free_vector(e1, 1, n);		/*  */
   free_vector(e2, 1, m);		/*  */
   free_vector(u, 1, n);
   free_vector(v, 1, m);

   free_vector(s, 1, IMIN(n, m));
}

void
rc_trunc_gen_inv(double **a, double **y, int m, int n, int r)
 /* ðʬѤ̵չη׻=-Ȥʤ롣a[1..m][1..n] */
 /* y[1..n][1..m]Ǥ롣*/
{
   double	**AtA, **AAt, *s1, *s2, *e1, *e2, *s, *u, *v;
   int		i, j, k;

   AtA = matrix(1, n, 1, n);	/* t */
   AAt = matrix(1, m, 1, m);	/* t */

   s1 = recipes_vector(1, n);		/* tθͭ */
   s2 = recipes_vector(1, m);		/* tθͭ */
   e1 = recipes_vector(1, n);		/*  */
   e2 = recipes_vector(1, m);		/*  */
   u = recipes_vector(1, n);
   v = recipes_vector(1, m);

   s = recipes_vector(1, IMIN(n, m));

   /* tη׻ */
   for (i = 1; i <= n; i++)
      for (j = 1; j <= n; j++)
      {
	 AtA[i][j] = 0.0;
	 for (k = 1; k <= m; k++)
	    AtA[i][j] += a[k][i] * a[k][j];
      }

   /* tη׻ */
   for (i = 1; i <= m; i++)
      for (j = 1; j <= m; j++)
      {
	 AAt[i][j] = 0.0;
	 for (k = 1; k <= n; k++)
	    AAt[i][j] += a[i][k] * a[j][k];
      }

   /* tθͭͤȸͭ٥ȥ(=) */
   tred2(AtA, n, s1, e1);
   tqli(s1, e1, n, AtA);
   eigsrt(s1, AtA, n);

/*   printf("\nAtAθͭ\n");
   for (i = 1; i <= n; i++)
      printf("%f ", s1[i]);
   printf("\n");
*/
   /* tθͭͤȸͭ٥ȥ(=) */
   tred2(AAt, m, s2, e2);
   tqli(s2, e2, m, AAt);
   eigsrt(s2, AAt, m);

/*   printf("AAtθͭ\n");
   for (i = 1; i <= m; i++)
      printf("%f ", s2[i]);
   printf("\n");
*/
   /* r׻ */
   if (n < m)
   {
      for (i = 1; i <= n; i++)
      {
	 if (i <= r)
	    s[i] = 1.0 / sqrt(s1[i]);
	 else
	    s[i] = 0.0;
      }
   }
   else
   {
      for (i = 1; i <= m; i++)
      {
	 if (i <= r)
	    s[i] = 1.0 / sqrt(s2[i]);
	 else
	    s[i] = 0.0;
      }
   }

   /* ꥢ */
   for (i = 1; i <= n; i++)
      for (j = 1; j <= m; j++)
	 y[i][j] = 0.0;

   for (k = 1; k <= r; k++)
   {
      column(AtA, n, n, u, k);
      for (i = 1; i <= m; i++)
      {
	 v[i] = 0.0;
	 for (j = 1; j <= n; j++)
	    v[i] += a[i][j] * u[j] * s[k];
      }

      for (i = 1; i <= n; i++)
	 for (j = 1; j <= m; j++)
	    y[i][j] += s[k] * u[i] * v[j];
   }

   /* ޥȥꥯ٥ȥγ */
   free_matrix(AtA, 1, n, 1, n);	/* t */
   free_matrix(AAt, 1, m, 1, m);	/* t */

   free_vector(s1, 1, n);		/* tθͭ */
   free_vector(s2, 1, m);		/* tθͭ */
   free_vector(e1, 1, n);		/*  */
   free_vector(e2, 1, m);		/*  */
   free_vector(u, 1, n);
   free_vector(v, 1, m);

   free_vector(s, 1, IMIN(n, m));
}
