#include <iostream>

using std::cerr;
using std::endl;

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <Vec.h>
#include <Mat.h>
#include "Tensor_used_by_matcher.h"
#include "Cast_used_by_matcher.h"
#include "miscfunc.h"

//
// Tensor4
//

// ijklƥ󥽥륯饹

// ݴؿ(4)
double****
alloc_mem(int in, int jn, int kn, int ln)
{
   double****	t;

   // 
   // ƤǤ0˽ʤ
   
   t = new double***[in];
   for (int i = 0; i < in; i++)
   {
      t[i] = new double**[jn];
      for (int j = 0; j < jn; j++)
      {
	 t[i][j] = new double*[kn];
	 for (int k = 0; k < kn; k++)
	 {
	    t[i][j][k] = new double[ln];
//	    for (int l = 0; l < ln; l++)
//	       t[i][j][k][l] = 0.0;
	 }
      }
   }
   
   return t;
}

// 1st constructor
Tensor4::Tensor4(int i, int j, int k, int l)
{
   in = i; jn = j; kn = k; ln = l;
   t = alloc_mem(in, jn, kn, ln);
}

// copy constructor
Tensor4::Tensor4(const Tensor4& T)
{
   in = T.in; jn = T.jn; kn = T.kn; ln = T.ln;
   t = alloc_mem(in, jn, kn, ln);
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
	 for (int k = 0; k < kn; k++)
	    for (int l = 0; l < ln; l++)
	       t[i][j][k][l] = T.t[i][j][k][l];
}

// Ѵ
Tensor4::Tensor4(const Tensor3333& T)
{
   in = T.in; jn = T.jn; kn = T.kn; ln = T.ln;
   t = alloc_mem(in, jn, kn, ln);
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
	 for (int k = 0; k < kn; k++)
	    for (int l = 0; l < ln; l++)
	       t[i][j][k][l] = T.t[i][j][k][l];
}

// destructor
Tensor4::~Tensor4()
{
   for (int i = 0; i < in; i++)
   {
      for (int j = 0; j < jn; j++)
      {
	 for (int k = 0; k < kn; k++)
	    delete [] t[i][j][k];
	 delete [] t[i][j];
      }
      delete [] t[i];
   }
   delete [] t;
}

// ꥢ
void
Tensor4::clear(double data)
{
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
         for (int k = 0; k < kn; k++)
            for (int l = 0; l < ln; l++)
               t[i][j][k][l] = data;
}

// ǼФ
double&
Tensor4::operator() (int i, int j, int k, int l)
{
   if (i >= 0 && i < in && j >= 0 && j < jn &&
       k >= 0 && k < kn && l >= 0 && l < ln)
      return t[i][j][k][l];

   cerr << "Function operator() error!\n";
   exit(1);
}

// ǼФ2
const double&
Tensor4::operator() (int i, int j, int k, int l) const
{
   if (i >= 0 && i < in && j >= 0 && j < jn &&
       k >= 0 && k < kn && l >= 0 && l < ln)
      return t[i][j][k][l];

   cerr << "Function operator() error!\n";
   exit(1);
}

// 
Tensor4&
Tensor4::operator = (const Tensor4& rhs)
{
   if (this == &rhs) return *this;

   if (in == rhs.in && jn == rhs.jn &&
       kn == rhs.kn && ln == rhs.ln)
   {
      for (int i = 0; i < in; i++)
	 for (int j = 0; j < jn; j++)
	    for (int k = 0; k < kn; k++)
	       for (int l = 0; l < ln; l++)
		  t[i][j][k][l] = rhs.t[i][j][k][l];
      
      return *this;
   }
   else
   {
      cerr << "Function Tensor4::operator = error!\n";
      exit(1);
   }
}

// 黻(+=)
Tensor4&
Tensor4::operator += (const Tensor4& rhs)
{
   if (in == rhs.in && jn == rhs.jn &&
       kn == rhs.kn && ln == rhs.ln)
   {
      for (int i = 0; i < in; i++)
	 for (int j = 0; j < jn; j++)
	    for (int k = 0; k < kn; k++)
	       for (int l = 0; l < ln; l++)
		  t[i][j][k][l] += rhs.t[i][j][k][l];
      
      return *this;
   }
   else
   {
      cerr << "Function Tensor4::operator += error!\n";
      exit(1);
   }
}

// 黻(-=)
Tensor4&
Tensor4::operator -= (const Tensor4& rhs)
{
   if (in == rhs.in && jn == rhs.jn &&
       kn == rhs.kn && ln == rhs.ln)
   {
      for (int i = 0; i < in; i++)
	 for (int j = 0; j < jn; j++)
	    for (int k = 0; k < kn; k++)
	       for (int l = 0; l < ln; l++)
		  t[i][j][k][l] -= rhs.t[i][j][k][l];
      
      return *this;
   }
   else
   {
      cerr << "Function Tensor4::operator -= error!\n";
      exit(1);
   }
}

// 黻(*=)
Tensor4&
Tensor4::operator *= (const double r)
{
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
         for (int k = 0; k < kn; k++)
            for (int l = 0; l < ln; l++)
               t[i][j][k][l] *= r;
   return *this;
}

// 黻(/=)
Tensor4&
Tensor4::operator /= (const double r)
{
   if (r == 0.0)
   {
      cerr << "Function Tensor4::operator /= error! divided by 0\n";
      exit(1);
   }
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
         for (int k = 0; k < kn; k++)
            for (int l = 0; l < ln; l++)
               t[i][j][k][l] /= r;
   return *this;
}

// ­
Tensor4
operator + (const Tensor4& T1, const Tensor4& T2)
{
   if (T1.in == T2.in && T1.jn == T2.jn &&
       T1.kn == T2.kn && T1.ln == T2.ln)
   {
      Tensor4 ans(T1.in, T1.jn, T1.kn, T1.ln);
      for (int i = 0; i < T1.in; i++)
	 for (int j = 0; j < T1.jn; j++)
	    for (int k = 0; k < T1.kn; k++)
	       for (int l = 0; l < T1.ln; l++)
		  ans.t[i][j][k][l] = T1.t[i][j][k][l] + T2.t[i][j][k][l];
      return ans;
   }

   cerr << "Function operator + error!\n";
   exit(1);
}

// 
Tensor4
operator - (const Tensor4& T1, const Tensor4& T2)
{
   return T1 + (-T2);
}

// ȤΤ
Tensor4
operator * (const Tensor4& T1, double r)
{
   Tensor4 ans(T1.in, T1.jn, T1.kn, T1.ln);
   
   for (int i = 0; i < T1.in; i++)
      for (int j = 0; j < T1.jn; j++)
	 for (int k = 0; k < T1.kn; k++)
	    for (int l = 0; l < T1.ln; l++)
	       ans.t[i][j][k][l] = T1.t[i][j][k][l] * r;
   
   return ans;
}

Tensor4
operator * (const double r, const Tensor4& T1)
{
   return T1 * r;
}

// 任
Tensor4
operator / (const Tensor4& T1, const double r)
{
   Tensor4 ans(T1.in, T1.jn, T1.kn, T1.ln);
   
   for (int i = 0; i < T1.in; i++)
      for (int j = 0; j < T1.jn; j++)
	 for (int k = 0; k < T1.kn; k++)
	    for (int l = 0; l < T1.ln; l++)
	       ans.t[i][j][k][l] = T1.t[i][j][k][l] / r;
   
   return ans;
}

// 洹
Tensor4
operator - (const Tensor4& T)
{
   Tensor4 ans(T.in, T.jn, T.kn, T.ln);
   
   for (int i = 0; i < T.in; i++)
      for (int j = 0; j < T.jn; j++)
	 for (int k = 0; k < T.kn; k++)
	    for (int l = 0; l < T.ln; l++)
	       ans.t[i][j][k][l] = -T.t[i][j][k][l];
   
   return ans;
}

// ƥ󥽥(2Ĥι33˸¤)
Tensor4
TensorProduct(const Mat& m1, const Mat& m2)
{
   Tensor4	ret;
   
   for (int i = 0; i < 3; i++)
      for (int j = 0; j < 3; j++)
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	       ret(i, j, k, l) = m1[i][j]*m2[k][l];
   return ret;
}

// (33)(33)ƥ󥽥θͭͤȸͭ
int
Eigen3333sym(const Tensor4& T, VecC& val, Mat* mat)
{
   Mat	M = Type66(T);
   Mat	evec(6, 6);  //ͭ٥ȥ
   
   eigen_vector(M, evec, val);
   for (int i = 0; i < 6; i++)
      mat[i] = Type33sym(evec(i));
      
   return 1;
}

// 3333ƥ󥽥θͭͤȸͭ
int
Eigen3333(const Tensor4& T, VecC& val, Mat* mat)
{
   Mat	M = Type99(T);
   Mat	eigenvectors(9, 9);  //ͭ٥ȥ
   
   eigen_vector(M, eigenvectors, val);
   for (int i = 0; i < 9; i++)
      mat[i] = Type33(eigenvectors(i));
      
   return 1;
}


// (33)(33)ƥ󥽥ΰ̵դ
Tensor4
GenInv3333sym(const Tensor4& T, int times)
{
   Mat	M = Type66(T);
   Mat	TT(6,6);
   Mat	EgVec(6,6);
   VecC	EgVal(6);	

   eigen_vector(M, EgVec, EgVal);
   TT.clear(0.0);
   for (int i = 0; i < times; i++)
      TT += EgVec(i) * (~EgVec(i)) / EgVal[i];
   return Type3333sym(TT);
}

// 3333ƥ󥽥ΰ̵դ
Tensor4
GenInv3333(const Tensor4& T, int times)
{
   return Type3333(trc_gen_inv(Type99(T), times));
}

//////////////////////////////////////////////////////////////////////
//
// Tensor3333
//

// 1st constructor
Tensor3333::Tensor3333()
{
   in = jn = kn = ln = 3;
   t = alloc_mem(in, jn, kn, ln);
}

// copy constructor
Tensor3333::Tensor3333(const Tensor3333& T)
{
   in = jn = kn = ln = 3;
   t = alloc_mem(in, jn, kn, ln);
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
	 for (int k = 0; k < kn; k++)
	    for (int l = 0; l < ln; l++)
	       t[i][j][k][l] = T.t[i][j][k][l];
}

// copy constructor
Tensor3333::Tensor3333(const Tensor4& T)
{
   if (T.in == 3 && T.jn == 3 && T.kn == 3 && T.ln == 3)
   {
      in = jn = kn = ln = 3;
      t = alloc_mem(in, jn, kn, ln);
      for (int i = 0; i < in; i++)
	 for (int j = 0; j < jn; j++)
	    for (int k = 0; k < kn; k++)
	       for (int l = 0; l < ln; l++)
		  t[i][j][k][l] = T.t[i][j][k][l];
   }
   else
   {
      cerr << "Tensor4 can not be convert to Tensor3333" << endl;
      exit(1);
   }
}

// destructor
Tensor3333::~Tensor3333()
{
   for (int i = 0; i < in; i++)
   {
      for (int j = 0; j < jn; j++)
      {
	 for (int k = 0; k < kn; k++)
	    delete [] t[i][j][k];
	 delete [] t[i][j];
      }
      delete [] t[i];
   }
   delete [] t;
}

// ꥢ
void
Tensor3333::clear(double data)
{
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
         for (int k = 0; k < kn; k++)
            for (int l = 0; l < ln; l++)
               t[i][j][k][l] = data;
}

// ǼФ
double&
Tensor3333::operator() (int i, int j, int k, int l)
{
   if (i >= 0 && i < in && j >= 0 && j < jn &&
       k >= 0 && k < kn && l >= 0 && l < ln)
      return t[i][j][k][l];

   cerr << "Function operator() error!\n";
   exit(1);
}

// ǼФ2
const double&
Tensor3333::operator() (int i, int j, int k, int l) const
{
   if (i >= 0 && i < in && j >= 0 && j < jn &&
       k >= 0 && k < kn && l >= 0 && l < ln)
      return t[i][j][k][l];

   cerr << "Function operator() error!\n";
   exit(1);
}

// 
Tensor3333&
Tensor3333::operator = (const Tensor3333& rhs)
{
   if (this == &rhs) return *this;

   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
	 for (int k = 0; k < kn; k++)
	    for (int l = 0; l < ln; l++)
	       t[i][j][k][l] = rhs.t[i][j][k][l];
      
   return *this;
}

// 黻(+=)
Tensor3333&
Tensor3333::operator += (const Tensor3333& rhs)
{
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
	 for (int k = 0; k < kn; k++)
	    for (int l = 0; l < ln; l++)
	       t[i][j][k][l] += rhs.t[i][j][k][l];
      
   return *this;
}

// 黻(-=)
Tensor3333&
Tensor3333::operator -= (const Tensor3333& rhs)
{
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
	 for (int k = 0; k < kn; k++)
	    for (int l = 0; l < ln; l++)
	       t[i][j][k][l] -= rhs.t[i][j][k][l];
      
   return *this;
}

// 黻(*=)
Tensor3333&
Tensor3333::operator *= (const double r)
{
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
         for (int k = 0; k < kn; k++)
            for (int l = 0; l < ln; l++)
               t[i][j][k][l] *= r;
   return *this;
}

// 黻(/=)
Tensor3333&
Tensor3333::operator /= (const double r)
{
   if (r == 0.0)
   {
      cerr << "Function Tensor3333::operator /= error! divided by 0\n";
      exit(1);
   }
   for (int i = 0; i < in; i++)
      for (int j = 0; j < jn; j++)
         for (int k = 0; k < kn; k++)
            for (int l = 0; l < ln; l++)
               t[i][j][k][l] /= r;
   return *this;
}

// ­
Tensor3333
operator + (const Tensor3333& T1, const Tensor3333& T2)
{
   Tensor3333	T;
   for (int i = 0; i < T.in; i++)
      for (int j = 0; j < T.jn; j++)
	 for (int k = 0; k < T.kn; k++)
	    for (int l = 0; l < T.ln; l++)
	       T.t[i][j][k][l] = T1.t[i][j][k][l] + T2.t[i][j][k][l];
   return T;
}

// 
Tensor3333
operator - (const Tensor3333& T1, const Tensor3333& T2)
{
   return T1 + (-T2);
}

// ȤΤ
Tensor3333
operator * (const Tensor3333& T1, double r)
{
   Tensor3333	T;
   
   for (int i = 0; i < T.in; i++)
      for (int j = 0; j < T.jn; j++)
	 for (int k = 0; k < T.kn; k++)
	    for (int l = 0; l < T.ln; l++)
	       T.t[i][j][k][l] = T1.t[i][j][k][l] * r;
   
   return T;
}

Tensor3333
operator * (const double r, const Tensor3333& T1)
{
   return T1 * r;
}

// (3333ƥ󥽥*33)
Mat
operator * (const Tensor3333& T, const Mat& M)
{
   return Type33(Type99(T) * Type9(M));
}

// 任
Tensor3333
operator / (const Tensor3333& T1, const double r)
{
   Tensor3333	T;
   
   for (int i = 0; i < T1.in; i++)
      for (int j = 0; j < T1.jn; j++)
	 for (int k = 0; k < T1.kn; k++)
	    for (int l = 0; l < T1.ln; l++)
	       T.t[i][j][k][l] = T1.t[i][j][k][l] / r;
   
   return T;
}

// 洹
Tensor3333
operator - (const Tensor3333& T)
{
   Tensor3333	ans;
   
   for (int i = 0; i < T.in; i++)
      for (int j = 0; j < T.jn; j++)
	 for (int k = 0; k < T.kn; k++)
	    for (int l = 0; l < T.ln; l++)
	       ans.t[i][j][k][l] = -T.t[i][j][k][l];
   
   return ans;
}

// (33)(33)ƥ󥽥θͭͤȸͭ
int
Eigen3333sym(const Tensor3333& T, VecC& val, Mat* mat)
{
   Mat	M = Type66(T);
   Mat	evec(6, 6);  //ͭ٥ȥ
   
   eigen_vector(M, evec, val);
   for (int i = 0; i < 6; i++)
      mat[i] = Type33sym(evec(i));
      
   return 1;
}

// 3333ƥ󥽥θͭͤȸͭ
int
Eigen3333(const Tensor3333& T, VecC& val, Mat* mat)
{
   Mat	M = Type99(T);
   Mat	eigenvectors(9, 9);  //ͭ٥ȥ
   
   eigen_vector(M, eigenvectors, val);
   for (int i = 0; i < 9; i++)
      mat[i] = Type33(eigenvectors(i));
      
   return 1;
}


// (33)(33)ƥ󥽥ΰ̵դ
Tensor3333
GenInv3333sym(const Tensor3333& T, int times)
{
   Mat	M = Type66(T);
   Mat	TT(6,6);
   Mat	EgVec(6,6);
   VecC	EgVal(6);	

   eigen_vector(M, EgVec, EgVal);
   TT.clear(0.0);
   for (int i = 0; i < times; i++)
      TT += EgVec(i) * (~EgVec(i)) / EgVal[i];
   return Type3333sym(TT);
}

// 3333ƥ󥽥ΰ̵դ
Tensor3333
GenInv3333(const Tensor3333& T, int times)
{
   return Type3333(trc_gen_inv(Type99(T), times));
}

// ƥ󥽥(2Ĥι33˸¤)
Tensor3333
tensor_product(const Mat& m1, const Mat& m2)
{
   Tensor3333 ret;
   
   for (int i = 0; i < 3; i++)
      for (int j = 0; j < 3; j++)
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	       ret(i, j, k, l) = m1[i][j]*m2[k][l];
   return ret;
}

// 3333ƥ󥽥Υȥ졼׻
double
trace(const Tensor3333& T)
{
   double	ans = 0.0;

   for (int m = 0; m < 3; m++)
      for (int n = 0; n < 3; n++)
	 ans += T(m, n, m ,n);

   return ans;
}

//ͱƥƥ󥽥׻
Tensor3333
projection(const Mat& M)
{
  Tensor3333	P;

  for (int i = 0; i < 3; i++)
     for (int j = 0; j < 3; j++)
	for (int k = 0; k < 3; k++)
	   for (int l = 0; l < 3; l++)
	   {
	      P(i,j,k,l) = Kronecker_delta(i,k) * Kronecker_delta(j,l)
		 - M[i][j] * M[k][l];
	   }
  return P;
}


//ͱƥƥ󥽥׻
Tensor3333
pseudo_projection(const Mat& M)
{
  Tensor3333	P;
  double	Mnorm;
  
  Mnorm = M.sqrnorm();
  for (int i = 0; i < 3; i++)
     for (int j = 0; j < 3; j++)
	for (int k = 0; k < 3; k++)
	   for (int l = 0; l < 3; l++)
	   {
	      P(i,j,k,l) = Kronecker_delta(i,k) * Kronecker_delta(j,l) 
		 - M[i][j] * M[k][l] / Mnorm;
	   } 

  return P;      
}

// ʣˤ3333ƥ󥽥
void
Tensor3333::fill()
{
   for (int i = 0; i < 3; i++)
      for (int j = 0; j < 3; j++)
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	       if (3*i+j > 3*k+l)
		  t[i][j][k][l] = t[k][l][i][j];
}

// ʣˤ(33)(33)ƥ󥽥
void
Tensor3333::fill_sym()
{
   for (int i = 0; i < 3; i++)
      for (int j = 0; j < 3; j++)
	 for (int k = 0; k < 3; k++)
	    for (int l = 0; l < 3; l++)
	    {
	       if (k > l)
		  t[i][j][k][l] = t[i][j][l][k];
	       else if (i > j)
		  t[i][j][k][l] = t[j][i][k][l];
	       else if (3*(i-1)+j > 3*(k-1)+l)
		  t[i][j][k][l] = t[k][l][i][j];
	    }
}
