#include <stdlib.h>
#include <math.h>
#include <Mat.h>
#include <Vec.h>
#include "CrsPair.h"
#include "geometric_test.h"


// 襤饤ؿ
static inline double
sqr(double x)
{
   return x * x;
}


///////եƥ////////////////////////////////////////////////////
// Ǿˡ
static void calc_affine_ls(VecC* x0, VecC* x1, double f0, int N, Mat& A)
{
   double	xc, yc, xpc, ypc;
   double	x, y, xp, yp;
   Mat          M0(2,2), M1(2,2), a(2,2);

   // ſη׻
   xc = yc = 0.0;
   xpc = ypc = 0.0;
   for (int i = 0; i < N; i++)
   {
      xc += x0[i][0];
      yc += x0[i][1];
      xpc += x1[i][0];
      ypc += x1[i][1];
   }
   xc /= (double)N;
   yc /= (double)N;
   xpc /= (double)N;
   ypc /= (double)N;

   // ſѰ̤Υ⡼ȹ
   M0.clear(0.0);
   M1.clear(0.0);
   for (int i = 0; i < N; i++)
   {
      x = x0[i][0] - xc;
      y = x0[i][1] - yc;
      xp = x1[i][0] - xpc;
      yp = x1[i][1] - xpc;

      M0[0][0] += sqr(x);
      M0[1][1] += sqr(y);
      M0[0][1] += x * y;

      M1[0][0] += x * xp;
      M1[0][1] += y * xp;
      M1[1][0] += x * yp;
      M1[1][1] += y * yp;
   }
   M0[1][0] = M0[0][1];

   a = M1 * inverse(M0);

   A[0][0] = a[0][0];
   A[0][1] = a[0][1];
   A[1][0] = a[1][0];
   A[1][1] = a[1][1];
   A[0][2] = (xpc - (a[0][0] * xc + a[0][1] * yc)) / f0;
   A[1][2] = (ypc - (a[1][0] * xc + a[1][1] * yc)) / f0;
   A[2][0] = A[2][1] = 0.0;
   A[2][2] = 1.0;
}

//// եѴƥ
static int
affmattest(const Mat& A, int n, int m, double f0)
{
   double	d, d1, d2;

   if (fabs(A[0][2]) >= n/(2.0 * f0))
   {
//      cerr << "affmattest 1: fabs(A13) = " << fabs(A[0][2]) << endl;
      return 0;
   }
   if (fabs(A[1][2]) >= m/(2.0 * f0))
   {
//      cerr << "affmattest 2: fabs(A23) = " << fabs(A[1][2]) << endl;
      return 0;
   }

   d = A[0][0] * A[1][1] - A[1][0] * A[0][1];
   if (d <= 0.5 || d >= 2)
   {
//      cerr << "affmattest 3: d = " << d << endl;
      return 0;
   }

   d1 = sqrt(A[0][0] * A[0][0] + A[1][0] * A[1][0]);
   if (d1 <= 0.7 || d1 >= 1.4)
   {
//      cerr << "affmattest 4: d1 = " << d1 << endl;
      return 0;
   }

   d2 = sqrt(A[0][1] * A[0][1] + A[1][1] * A[1][1]);
   if (d2 <= 0.7 || d2 >= 1.4)
   {
//      cerr << "affmattest 5: d2 = " << d2 << endl;
      return 0;
   }

   d = fabs((A[0][0] * A[0][1] + A[1][0] * A[1][1]) / (d1 * d2));
   if (d >= 0.5)
   {
//      cerr << "affmattest 6: d = " << d << endl;
      return 0;
   }

   return 1;
}

int affinetest(CrsPair &crsp,int *index,int num)
{
  Mat A;//ե
  VecC p1[num],p2[num];
  int ret;
  
  //бμФ
  for(int i=0;i<num;i++) {
    p1[i].realloc(2);
    p2[i].realloc(2);

    //᤹
    p1[i][0] = crsp.fcslen * crsp.pp1[ index[i] ][0];
    p1[i][1] = crsp.fcslen * crsp.pp1[ index[i] ][1];
    p2[i][0] = crsp.fcslen * crsp.pp2[ index[i] ][0];
    p2[i][1] = crsp.fcslen * crsp.pp2[ index[i] ][1];
  }

  calc_affine_ls(p1, p2, crsp.fcslen, num, A );
  ret = affmattest(A, crsp.width, crsp.height, crsp.fcslen);

  return ret;
}



////////ƥ/////////////////////////////////////////////////////
// ؿ
static int
sgn(VecC& X1, VecC& X2, VecC& X3)
{
   VecC		dX1, dX2;
   double	x;

   dX1 = X2 - X1;
   dX2 = X3 - X2;
   // 
   x = dX1[0] * dX2[1] - dX1[1] * dX2[0];

   if (x > EPS)   return 1;
   if (x < -EPS)  return -1;
   return 0;
}

//ƥ
int signtest(CrsPair &cp,int *index,int num)
{
  int sgn1,sgn2;

  for(int i = 0,j = 1, k = 2; i < num; i++, j++, k++ ){
    if(j >= num) j=0;
    if(k >= num) k=0;

    sgn1 = sgn(cp.pp1[ index[i] ],
	       cp.pp1[ index[j] ],
	       cp.pp1[ index[k] ]);
    
    sgn2 = sgn(cp.pp2[ index[i] ],
	       cp.pp2[ index[j] ],
	       cp.pp2[ index[k] ]);
    
    if(sgn1 != sgn2){
      return 0;
    }

  }

  return 1;
}


//
