#include <iostream>

using std::cerr;
using std::endl;
using std::cout;

#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>

#include <Mat.h>
#include <Vec.h>

#include "CrsPair.h"
#include "geometric_test.h"//եƥ,ƥ
#include "fundamental.h"   //ù׻
#include "decomp_test.h"   //ùʬǽƥ
#include "ransac.h"

const int F_MIN_PTS = 8; //ù׻ѤĿκǾ

extern int flag;


void show_randam8(CrsPair &cp, int *index, int num)
{
  for(int i=0; i< num; i++){
	cerr <<i<<","<<index[i]<<endl;
	cerr <<"a "<<cp.pp1[index[i]]<<endl;
	cerr <<"b "<<cp.pp2[index[i]]<<endl;
  }
	
}

//ؿμ
static void set_seed()
{
  srand( time(NULL) );
}


//0rangeޤǤΥ֤ͤ
static int rand_num(int range)
{
  return rand()%range;
}

static void get_randam_pt_uniq(int *index,int range,int num)
{
  int ct=0;
  
  do{
    int flg=0;
    
    index[ct] = rand_num(range);
    for(int i=0;i<ct;i++){
      if(index[ct] == index[i]){	
	flg = 1;
	break;
      }
    }
    if(flg) continue;
    ct++;
  }while(ct < num);
  
}


/////////////////////////////////////////////////////////////////////////
//Ǿˡˤù׻
// crsp  б
//     index numֹ
//     num   ù׻ѤбθĿ(default 8ѤƤ)
//     F     ùǼ
//  0ʳ
//        0
//////////////////////////////////////////////////////////////////////////   
static int calc_fund_least_square ( CrsPair &crsp,int *index, Mat &F, int num)
{
  VecC p1[num],p2[num];
  //ԡ
  for(int i=0;i<num;i++){
    p1[i] = crsp.pp1[ index[i] ];
    p2[i] = crsp.pp2[ index[i] ];
  }

  int ret = calc_fundamental_ls(p1,p2,num,F);//Ǿˡ
  if(ret == SUCCEEDED)
    return 1;

  return 0;
}


//бǤ餷ɤ
//  crsp  б
//      index numֹ
//      num   ù׻ѤбθĿ(default 8 ѤƤ)
//      F     ùǼ
// Ǥ餷  0ʳ
//       Ǥ  0
static int calc_F_and_test(CrsPair &crsp,int *index,Mat &F,int num)
{
// 	cerr <<"sign test"<<endl;
//	show_randam8(crsp,index, num);
    //ƥ
    if( ! signtest(crsp,index,num)){
      //      cerr <<"sign test error"<<endl;
      return 0;
    }
// 	cerr <<"affine test"<<endl;

    //եƥ
    if( ! affinetest(crsp,index,num) ){
      //      cerr <<"affine test error"<<endl;
      return 0;
    }
// 	cerr <<"calc F ls"<<endl;

    //ùη׻
    if(! calc_fund_least_square(crsp,index,F,num) ){
      return 0;
    }
// 	cerr <<"decomp test"<<endl;

    //ʬǽȽ
    if(! F_decomp_test(F) ){
      //      cerr <<"decomp error"<<endl;
      return 0;
    }

    return 1;
}


///////////////////////////////////////////////////////////////////////////////
//«Ƚ
//   pp1,pp2 : (줿)бɸ
//       F       : ù()
//       d       : ǤεƸ
//       fl      : Υ
//
//  «   
//                ʤ 
///////////////////////////////////////////////////////////////////////////////
bool check_condition_of_constraint(VecC &pp1, VecC &pp2,Mat &F,double epsilon,int verbose)
{
  Mat Pk(1,0,0,
	 0,1,0,
	 0,0,0);
  VecC Ta,Tb;
  double det,J;

  Ta = Pk * (~F) * pp1 ;
  Tb = Pk * F * pp2 ;
  det = Ta.sqrnorm() +  Tb.sqrnorm();

  if(det == 0){
    cerr <<"0 divided in check_condition_of_constraint func.\n"
	 <<"correlation point may be (0,0,0)"<<endl;
    //    exit(ERROR_ZERODIVID);
    return false;
  }

  J = (pp1 , (F * pp2) );
  J = J * J / det;

  

  if(verbose){//Ĺ٥
    fprintf(stderr,
	    "(%6.4f,%6.4f)--(%6.4f,%6.4f): ",
	    pp1[0] ,pp1[1], pp2[0],pp2[1]);
    cerr << J <<","<<epsilon;
  }


  if(J < epsilon){
    if(verbose){
      cerr <<" T \n";
    }
    return true;
  }
  else{
    if(verbose ){
      cerr <<"\n";
    }
    return false ;
  }

}


//ݡͤλ
// ݡȿ
static int calc_support_F(CrsPair &crsp,  Mat &F,double &support_probability, double epsilon,int verbose)

{
  int support_num=0;//ݡȤο


  support_probability = 0.0;
  for(int i=0;i<crsp.corres_num;i++){

    //«
    if( check_condition_of_constraint(crsp.pp1[i],crsp.pp2[i], 
				      F, epsilon,verbose)  ){
      //ݡͤݻ
      support_num ++;
      support_probability += crsp.cumul_prob[i];
    }

  }
  return support_num;
}



////////////////////////////////////////////////////////////////////////
//RANSACˤùο
//
//  crsp               б
//  use_num_by_calc_F  ù˻Ѥбο
//  epsilon            0Ȥߤʤ
//  not_found_count    λǤ롢̵Ѳ
//  verbose            Ĺɽ
//  F_result           ùǼ
//  祵ݡ
///////////////////////////////////////////////////////////////////////
int ransac_fundamental(CrsPair &crsp,
		       double epsilon,int not_found_count,
		       int verbose,
		       Mat &F_result)
{    
  int Snum ,Snum_max;        //ݡȤο
  double Sp,Sp_max;             //Ψ
  Mat F;                        //׻ùǼ
  int count,ct;                 //֤Ƚ
  int index[8]; //ùѤбֹ
  int MaxItr = 40000;           //ȿ
  int use_num_by_calc_F = 8;//ɬ8ǹԤ

  //
  set_seed();          //μ
  F_result.clear(0.0);
  Snum_max = -1;
  Sp_max   = -1.0;
  count = ct = 0;

  //бʲ᤮,ù󤬷׻Ǥʤɤ
  if(crsp.corres_num < F_MIN_PTS){
    cerr << "too few number of correlation point to calculate Fundamental matrix"<<endl;
    return crsp.corres_num;
  }
  

  //RANSAC
  while(count++ < MaxItr){
    //
    get_randam_pt_uniq(index,crsp.corres_num,use_num_by_calc_F);
    //бȽ,ùη׻
    if( ! calc_F_and_test(crsp, index, F, use_num_by_calc_F ) ){
      //      count--;//̵¥롼פ˴٤ǽ
      continue;
    }
    
    if(verbose){ 
      cerr << count <<" : F\n"
	   <<F<<"\n";
      
      cerr << "point :\n";
      for(int i=0;i<use_num_by_calc_F;i++){
	cerr << "("<<crsp.pp1[index[i]][0]*crsp.fcslen
	     <<","<<crsp.pp1[index[i]][1]*crsp.fcslen
	     <<")--("
	     <<crsp.pp2[index[i]][0]*crsp.fcslen
	     <<","<<crsp.pp2[index[i]][1]*crsp.fcslen<<")\n\n";
      }
    }
    
    //ݡȤη׻
    Sp = 0;
    Snum = calc_support_F(crsp,F,Sp,epsilon,verbose);

    
    if(verbose){
      cerr <<  "support :"<<Snum <<","<<Sp;
    }
	 
    

    //
    if(Snum >= Snum_max && Sp > Sp_max){
      if(verbose ){
	cerr << " ";
      }
      Snum_max = Snum;
      Sp_max   = Sp;
      F_result = F;
      ct       = 0;

    }else{

      if(++ct >= not_found_count){
      //ꤷ󹹿ʤäΤǽλ
	break;      
      }

    }
    if(verbose){
      cerr <<"\n\n\n";
    }

  }

  if(ct >= MaxItr)
    cerr <<"\nThe count exceeded Max-iterator-count\n";
  return Snum_max;
}
